#include "Experiment.h"
#include "Leviathan.h"

#include <fstream>
#include <iostream>
#include <sstream>

template <typename T>
std::string to_string_with_precision(const T a_value, const int n = 6)
{
    std::ostringstream out;
    out.precision(n);
    out << std::fixed << a_value;
    return out.str();
}

void changeOfReputationPerAgent(float range,float sigma,float delta,
                                unsigned int nbGossip, unsigned int nbAgent,
                                unsigned int nbReplica,unsigned int nbInteractions){
  std::ofstream myfile;
  float minOther=-range/2.;
  std::string file_name="simulation_range=" +to_string_with_precision(range, 2) +"_sigma="+to_string_with_precision(sigma, 2)+
    "_delta="+to_string_with_precision(delta, 2)+"_k="+std::to_string(nbGossip)+"_Na="+std::to_string(nbAgent)+"_nbRep="+std::to_string(nbReplica)+
    "_nbInterac="+std::to_string(nbInteractions)+".csv";
  std::cout<<file_name<<std::endl;
  myfile.open(file_name);
  Leviathan lev(delta,sigma,nbAgent,nbGossip);
  lev.useBorder=false;
  lev.oneInteractionParStep=true;
  std::vector<float> baseOpinions(nbAgent,0);
  float op=minOther;
  for(float o=0;o<nbAgent;o++){
    baseOpinions[o]=op;
    op+=range/(nbAgent-1);
  }
  std::vector<std::vector<std::vector<float>>> sum_opinions(nbAgent,std::vector<std::vector<float>>(nbAgent,std::vector<float>(nbInteractions,0)));
  std::vector<std::vector<std::vector<float>>> sum_opinions2(nbAgent,std::vector<std::vector<float>>(nbAgent,std::vector<float>(nbInteractions,0)));
  std::vector<std::vector<std::vector<float>>> sum_opinions3(nbAgent,std::vector<std::vector<float>>(nbAgent,std::vector<float>(nbInteractions,0)));
  float OpAii;
  float baseOpAii;

  for(unsigned int r=0;r<nbReplica;r++){
    if(r%10000==0)
      std::cout<<r<<std::endl;
    for(IdAgent a=0;a<lev.getNbAgents();a++){
      lev.setAgentReputation(a,baseOpinions[a]);
    }
    for(unsigned int i=0;i<nbInteractions;i++){
      lev.step();
      for(IdAgent a1=0;a1<lev.getNbAgents();a1++){
        OpAii=lev.getOpinion(a1,a1);
        baseOpAii=baseOpinions[a1];
        for(IdAgent a2=0;a2<lev.getNbAgents();a2++){
          sum_opinions[a2][a1][i]+=  lev.getOpinion(a2,a1)-baseOpAii;
          sum_opinions2[a2][a1][i]+=  pow(lev.getOpinion(a2,a1)-baseOpAii,2);
          sum_opinions3[a2][a1][i]+=  (lev.getOpinion(a2,a1)-baseOpAii)*(OpAii-baseOpAii);
        }
      }
    }
  }
  myfile<<"step,rep(m),rep(y),m,y,xii2,xji2,xiiji";
  myfile<<std::endl;
  for(IdAgent a1=0;a1<nbAgent;a1++){
    for(unsigned int st=0;st<nbInteractions;st++){
      for(IdAgent a2=0;a2<nbAgent;a2++){
        if(a1!=a2){
          myfile<<st<<","<<baseOpinions[a1]<<","<<baseOpinions[a2]<<","<<sum_opinions[a1][a1][st]/nbReplica<<","<<sum_opinions[a2][a1][st]/nbReplica;
          myfile<<","<<sum_opinions2[a1][a1][st]/nbReplica<<","<<sum_opinions2[a2][a1][st]/nbReplica<<","<<sum_opinions3[a2][a1][st]/nbReplica<<std::endl;
        }
      }
    }
  }
  myfile.close();
}
